<template>
  <div class="switcher-container">
    <div
      v-for="canvas, index in canvases"
      :key="index"
      class="canvas-switcher"
    >
      <template v-if="canvas.availableSources.length && openedSources[index]">
        <canvas-switcher-menu>
          <!-- The dropdown menu to select a source -->
          <canvas-switcher-select
            v-if="canvas.availableSources.length > 1"
            :value="openedSources[index].source"
            :items="canvas.availableSources"
            @input="setSource($event, index)"
          />
          <!-- Scale down button -->
          <canvas-switcher-button
            v-if="!openedSources[index].source.shouldSnap"
            icon="mdi-magnify-minus"
            :tooltip="$t('canvas-switcher.tooltip.scaleDown')"
            @click="openedSources[index].scale.exponent -= 1"
          />
          <canvas-switcher-button
            v-if="!openedSources[index].source.shouldSnap"
            icon="mdi-magnify-plus"
            :tooltip="$t('canvas-switcher.tooltip.scaleUp')"
            @click="openedSources[index].scale.exponent += 1"
          />
          <canvas-switcher-translator
            v-show="showTranslator"
            :signature="signature"
            :actions="actions"
            :is-seconds="!openedSources[index].source.shouldSnap"
            :possible-increments="possibleIncrements"
          />
        </canvas-switcher-menu>
        <div
          class="canvas-slot"
        >
          <slot
            :source="openedSources[index].source"
            :scale="openedSources[index].scale"
            :index="index"
            :zoom="openedSources[index].zoom"
          />
        </div>
      </template>
    </div>
    <canvas-switcher-menu>
      <canvas-switcher-button
        v-if="canAdd"
        icon="mdi-plus"
        :tooltip="$t('canvas-switcher.tooltip.open')"
        @click="$emit('add')"
      />
    </canvas-switcher-menu>
  </div>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, Watch,
} from 'vue-property-decorator';
import type { Signature, Source } from '@/data';
import Zoom from '@/logic/Zoom';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import CanvasSwitcherButton from './CanvasSwitcherButton.vue';
import CanvasSwitcherSelect from './CanvasSwitcherSelect.vue';
import CanvasSwitcherMenu from './CanvasSwitcherMenu.vue';
import CanvasSwitcherTranslator from './CanvasSwitcherTranslator.vue';
import type { Increment } from '../toolbars/synchronization/TapBar.vue';

interface SelectedSource {
  source: Source;
  scale: Zoom;
  zoom: Zoom;
}

export interface LimitedCanvas {
  availableSources: Source[];
}

/**
 * Like the canvas switcher, allows multiple sources
 *
 * However, the number of canvases are limited, and their options are locked to a set of choices
 */
@Component({
  components: {
    CanvasSwitcherButton,
    CanvasSwitcherSelect,
    CanvasSwitcherMenu,
    CanvasSwitcherTranslator,
  },
})
export default class LimitedCanvasSwitcher extends Vue {
  @Prop()
  possibleIncrements!: Increment[];

  /**
   * An array of objects describing the options of each canvas
   */
  @Prop()
  canvases!: LimitedCanvas[];

  @Prop({ default: false })
  canAdd!: boolean;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ required: true })
  actions!: SynchronizationActions;

  @Prop()
  showTranslator!: boolean;

  openedSources: (SelectedSource | null)[] = [];

  created() {
    this.mapCanvases();
  }

  mounted() {
    const switchers = document.getElementsByClassName('canvas-switcher');
    if (switchers.length) {
      for (let i = 0; i < switchers.length; i += 1) {
        const switcher = switchers.item(i);
        const height = switcher?.getBoundingClientRect().height || 1;
        const realHeight = switcher?.scrollHeight || 0;

        const top = realHeight / 2 - height / 2;
        switcher?.scroll({ top });
      }
    }
  }

  @Watch('canvases')
  mapCanvases() {
    this.openedSources = this.canvases.map((c) => {
      if (!c.availableSources.length) return null;

      return {
        source: c.availableSources[0],
        scale: new Zoom(),
        zoom: new Zoom(),
      };
    });
  }

  setSource(source: Source, index: number) {
    const scale = new Zoom();
    const zoom = new Zoom();
    Vue.set(this.openedSources, index, {
      source,
      scale,
      zoom,
    });
  }
}
</script>
<style scoped lang="scss">
.canvas-slot {
  box-shadow: 0 4px 4px 2px rgba(0, 0, 0, 0.14);
}

.canvas-switcher {
  &:nth-of-type(1) {
    height: 35%;
  }
  height: 65%;
  overflow-y: auto;
}
</style>
